extern "C" {
#define __KEYBIOS_H__
#include "fxlib.h"
#include "MonochromeLib.h"
#include "math.h"
#include "string.h"
}
#include <iostream>

 
#define KEY_CHAR_0 OS2(0x30,71)
#define KEY_CHAR_1 OS2(0x31,72)
#define KEY_CHAR_2 OS2(0x32,62)
#define KEY_CHAR_3 OS2(0x33,52)
#define KEY_CHAR_4 OS2(0x34,73)
#define KEY_CHAR_5 OS2(0x35,63)
#define KEY_CHAR_6 OS2(0x36,53)
#define KEY_CHAR_7 OS2(0x37,74)
#define KEY_CHAR_8 OS2(0x38,64)
#define KEY_CHAR_9 OS2(0x39,54)
#define KEY_CHAR_DP OS2(0x2e,61)
#define KEY_CHAR_EXP OS2(0x0f,51)
#define KEY_CHAR_PMINUS OS2(0x87,41)
#define KEY_CHAR_PLUS OS2(0x89,42)
#define KEY_CHAR_MINUS OS2(0x99,32)
#define KEY_CHAR_MULT OS2(0xa9,43)
#define KEY_CHAR_DIV OS2(0xb9,33)
#define KEY_CHAR_FRAC OS2(0xbb,75)
#define KEY_CHAR_LPAR OS2(0x28,55)
#define KEY_CHAR_RPAR OS2(0x29,45)
#define KEY_CHAR_COMMA OS2(0x2c,35)
#define KEY_CHAR_STORE OS2(0x0e,25)
#define KEY_CHAR_LOG OS2(0x95,66)
#define KEY_CHAR_LN OS2(0x85,56)
#define KEY_CHAR_SIN OS2(0x81,46)
#define KEY_CHAR_COS OS2(0x82,36)
#define KEY_CHAR_TAN OS2(0x83,26)
#define KEY_CHAR_SQUARE OS2(0x8b,67)
#define KEY_CHAR_POW OS2(0xa8,57)
#define KEY_CTRL_EXE OS2(30004,31)
#define KEY_CTRL_DEL OS2(30025,44)
#define KEY_CTRL_AC OS2(30015,32)
#define KEY_CTRL_FD OS2(30046,65)
#define KEY_CTRL_EXIT OS2(30002,47)
#define KEY_CTRL_SHIFT OS2(30006,78)
#define KEY_CTRL_ALPHA OS2(30007,77)
#define KEY_CTRL_OPTN OS2(30008,68)
#define KEY_CTRL_VARS OS2(30016,58)
#define KEY_CTRL_UP OS2(30018,28)
#define KEY_CTRL_DOWN OS2(30023,37)
#define KEY_CTRL_LEFT OS2(30020,38)
#define KEY_CTRL_RIGHT OS2(30021,27)
#define KEY_CTRL_F1 OS2(30009,79)
#define KEY_CTRL_F2 OS2(30010,69)
#define KEY_CTRL_F3 OS2(30011,59)
#define KEY_CTRL_F4 OS2(30012,49)
#define KEY_CTRL_F5 OS2(30013,39)
#define KEY_CTRL_F6 OS2(30014,29)
#define KEY_CTRL_MENU OS2(30003,48)
 
#ifndef isOS2// This is new
 
typedef int(*sc_i2cp2sip)(char*, char*, short int*, short int*);
const unsigned int sc0015[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0015 };
#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)
 
int OSVersionAsInt(void)
{
char mainversion;
char minorversion;
short release;
short build;
GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
}
 
#define isOS2 (OSVersionAsInt() >= 0x02020000)
#define OS2(x,y) ((OSVersionAsInt() >= 0x02020000)?y:x)
 
#endif
 
const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;
 
unsigned short key[8] = {0};
 
int KeyDown(int keycode)
{
if(isOS2)
{
int row, col, word, bit;
row = keycode%10;
col = keycode/10-1;
word = row>>1;
bit = col + 8*(row&1);
memcpy(key, keyboardregister, sizeof(unsigned short) << 3);
 
Sleep(1); //slow down, this function is faster than IsKeyDown() :-P
 
return (0 != (key[word] & 1<<bit));
}
else
{
return IsKeyDown(keycode);
}
}
 
#define IsKeyDown(x) KeyDown(x)
#define IsKeyUp(x) !KeyDown(x)

#define TAILLE 16

int score;
int niveau;
int oiseaux[5];
int cochons[3][4];
int terrain[20][4];
int xo,yo,so;
double force;
unsigned char enregistrement[TAILLE];
int Q1,Q3;


int abs(int n){
	if(n<0) n-=n;
	return n;
}

unsigned char* int2str(unsigned char* c, int n)
{
    if(n==0)
    {
        c[0] = '0';
        c[1] = 0;
    }
    else
    {
        int i, l=0;
        if(n<0)
        {
            c[0] = '-';
            n=abs(n);
            l++;
        }
        for(i=n ; i ; i/=10)
            l++;
        c[l] = 0;
        for(i=n ; i ; i/=10)
            c[--l] = i%10+'0';
    }
	return c;
}

int definitif(){
	const unsigned char definitif[] = {
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,
		34,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,
		34,64,128,64,1,128,0,0,0,0,0,0,0,0,0,0,
		34,12,134,20,97,128,0,0,0,0,0,0,0,0,0,0,
		34,82,233,90,145,128,0,0,0,0,0,0,0,0,0,0,
		34,80,137,80,241,128,0,0,0,0,0,0,0,0,0,0,
		20,82,137,80,128,0,0,0,0,0,0,0,0,0,0,0,
		8,76,102,80,113,128,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		15,255,255,255,128,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,6,4,128,0,0,0,0,0,0,0,
		0,0,0,0,0,0,9,10,128,0,0,0,0,0,0,0,
		0,0,0,0,0,0,10,245,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,9,0,236,0,0,0,0,15,0,0,
		0,0,0,0,0,0,4,0,18,0,0,0,0,63,192,0,
		0,0,0,0,0,0,9,128,2,0,0,0,0,127,240,0,
		0,0,0,0,0,0,16,192,68,0,0,0,0,255,248,0,
		0,0,0,0,0,0,32,0,194,0,0,0,0,255,248,0,
		0,0,0,0,0,0,32,0,129,0,0,0,1,255,248,0,
		0,0,0,0,0,0,32,24,0,128,0,0,1,255,228,0,
		0,0,0,0,0,0,92,12,0,128,0,0,1,255,2,0,
		0,0,0,0,0,0,98,0,28,128,0,0,1,192,49,0,
		0,0,0,0,0,0,66,126,30,128,0,0,0,128,33,0,
		0,0,0,0,0,0,90,129,62,128,0,0,0,64,6,0,
		0,0,0,0,0,0,117,6,188,128,0,0,63,255,8,0,
		0,0,0,0,0,0,93,102,152,128,63,255,192,0,255,192,
		0,0,0,0,0,0,65,96,128,255,192,0,0,0,0,63,
		0,0,0,0,0,0,33,0,128,128,0,0,0,0,0,0,
		0,0,0,0,0,0,32,255,1,0,0,0,0,0,0,0,
		0,0,0,0,0,127,216,0,2,0,0,0,0,0,0,0,
		0,0,0,127,255,128,4,62,12,0,0,0,0,0,0,0,
		0,127,255,128,0,0,3,128,112,0,0,0,0,0,0,0,
		255,128,0,0,0,0,0,127,128,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,64,
		64,0,0,32,0,0,1,0,0,128,16,0,0,16,8,64,
		64,0,0,32,0,0,1,0,0,128,16,0,0,16,8,64,
		66,49,145,177,17,140,137,202,74,230,50,43,17,16,8,64,
		69,66,42,42,170,17,85,10,172,136,85,48,170,144,0,0,
		70,34,42,42,169,9,85,10,200,132,86,33,171,16,64,8,
		68,18,42,42,168,133,85,10,136,130,84,34,154,0,48,48,
		51,97,145,169,43,24,148,132,104,76,51,33,137,144,95,192,
		0,0,0,0,0,0,0,0,0,0,0,0,28,0,72,0,
		0,0,0,0,0,0,0,0,0,0,0,0,40,0,48,0,
		0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0 };
	ML_clear_vram();
	ML_bmp_or_cl(definitif,0,0,128,64);
	ML_display_vram();
	Sleep(1500);
	while(IsKeyUp(KEY_CTRL_EXE));
	return 1;
}

void louloux(){
	const unsigned char fin[] = {
		15,255,255,255,255,255,255,255,255,255,255,255,255,255,255,240,
		31,255,255,255,255,255,255,255,255,255,255,255,255,255,255,248,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,0,255,255,255,255,255,0,255,255,255,255,255,255,255,252,
		63,0,255,255,255,255,255,0,255,255,255,255,255,255,255,252,
		63,0,255,255,255,255,255,0,255,255,255,255,255,255,255,252,
		63,0,255,255,255,255,255,0,255,255,255,255,255,255,255,252,
		63,255,15,255,255,255,255,255,15,255,255,255,255,255,255,252,
		63,255,15,255,255,255,255,255,15,255,255,255,255,255,255,252,
		63,255,15,255,255,255,255,255,15,255,255,255,255,255,255,252,
		63,255,15,255,255,255,255,255,15,255,255,255,255,255,255,252,
		63,255,15,255,15,240,240,255,15,255,15,240,240,240,240,252,
		63,255,15,255,15,240,240,255,15,255,15,240,240,240,240,252,
		63,255,15,255,15,240,240,255,15,255,15,240,240,240,240,252,
		63,255,15,255,15,240,240,255,15,255,15,240,240,240,240,252,
		63,255,15,240,240,240,240,255,15,240,240,240,240,255,15,252,
		63,255,15,240,240,240,240,255,15,240,240,240,240,255,15,252,
		63,255,15,240,240,240,240,255,15,240,240,240,240,255,15,252,
		63,255,15,240,240,240,240,255,15,240,240,240,240,255,15,252,
		63,255,15,255,15,255,15,255,15,255,15,255,15,240,240,252,
		63,255,15,255,15,255,15,255,15,255,15,255,15,240,240,252,
		63,255,15,255,15,255,15,255,15,255,15,255,15,240,240,252,
		63,255,15,255,15,255,15,255,15,255,15,255,15,240,240,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		63,255,255,255,255,255,255,255,255,255,255,255,255,255,255,252,
		31,255,255,255,255,255,255,255,255,255,255,255,255,255,255,248,
		15,255,255,255,255,255,255,255,255,255,255,255,255,255,255,240 };
		ML_clear_vram();
		ML_bmp_or_cl(fin,0,2,128,60);
		ML_display_vram();
		Sleep(200);
		while(IsKeyUp(KEY_CTRL_EXE));
}

void intro(){
	const unsigned char introduction[] = {
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,240,14,0,0,0,0,0,0,0,0,0,0,0,
		0,0,3,255,135,128,0,0,0,0,0,0,0,0,0,0,
		0,0,15,255,255,128,0,0,0,0,0,0,0,0,0,0,
		0,0,31,15,255,192,0,0,0,0,0,0,0,0,0,0,
		0,0,0,7,255,224,0,0,0,0,0,0,0,0,0,0,
		0,0,0,3,255,224,0,0,0,0,0,0,0,0,0,0,
		0,0,0,63,255,240,0,0,0,0,0,0,0,0,0,0,
		0,0,0,127,255,240,0,0,0,0,0,0,28,0,0,0,
		0,0,0,192,255,224,0,0,0,0,0,0,62,0,0,0,
		0,0,0,131,243,32,0,0,0,252,63,131,240,223,131,0,
		0,0,0,1,132,16,0,0,1,254,61,199,248,251,135,0,
		0,0,0,0,8,8,0,0,3,206,57,207,61,243,134,0,
		0,0,0,0,16,4,0,0,0,14,121,206,29,225,206,0,
		0,0,0,0,32,2,0,0,0,254,113,207,61,193,204,0,
		0,0,0,0,32,2,0,0,3,254,113,199,249,193,220,0,
		0,0,0,0,64,1,0,0,7,142,113,199,241,193,216,0,
		0,0,0,0,128,0,128,0,7,30,113,204,1,192,248,0,
		0,0,0,0,128,0,64,0,7,62,227,156,3,128,240,0,
		0,0,0,1,0,0,64,0,7,254,227,159,243,128,240,0,
		0,0,0,2,0,0,32,0,3,246,227,143,251,128,224,0,
		0,0,0,2,0,0,16,0,0,0,0,24,28,0,224,0,
		0,0,0,4,0,0,16,0,0,0,0,28,60,1,192,0,
		0,0,0,8,0,0,8,0,0,0,0,31,248,15,192,0,
		0,0,0,8,0,0,8,0,0,0,0,15,224,15,128,0,
		0,0,0,16,0,0,4,0,0,0,0,0,0,0,0,0,
		0,0,0,16,0,0,4,0,0,0,0,0,0,0,0,0,
		0,0,64,32,0,0,2,0,0,0,0,0,0,0,0,0,
		0,252,112,64,0,0,2,0,0,0,0,0,0,0,0,0,
		3,254,56,64,112,0,1,0,0,0,0,0,0,0,0,0,
		15,255,56,128,124,0,1,0,0,0,0,0,0,0,0,0,
		31,255,157,0,255,0,0,128,0,0,0,0,0,0,0,0,
		62,31,253,0,255,192,0,70,0,0,0,0,0,0,0,0,
		56,1,254,0,127,240,0,255,0,14,1,192,0,112,0,0,
		96,0,62,0,15,252,7,255,0,14,1,192,0,112,0,0,
		64,0,252,0,5,254,63,254,0,14,0,0,0,112,0,0,
		0,3,252,0,4,127,127,252,0,15,225,205,207,115,240,0,
		0,1,248,0,4,63,191,240,0,15,241,207,159,247,248,0,
		0,0,24,0,4,63,254,80,0,30,123,223,61,247,28,0,
		0,0,16,0,2,9,31,80,0,30,59,158,56,231,12,0,
		0,0,32,0,1,242,6,72,0,28,59,156,120,231,192,0,
		0,0,32,0,0,4,1,136,0,28,59,156,120,227,240,0,
		0,0,64,0,0,15,224,200,0,28,123,156,112,224,248,0,
		0,0,64,0,0,17,28,36,0,28,119,156,113,236,56,0,
		0,0,128,0,0,18,7,148,0,28,247,56,57,206,56,0,
		0,1,0,0,0,12,6,116,0,63,231,56,63,199,248,0,
		0,1,0,0,0,28,24,4,0,55,199,56,31,195,240,0,
		0,1,0,0,1,227,254,4,0,0,0,0,0,0,0,0,
		0,1,0,0,14,0,1,196,0,0,0,0,0,0,0,0,
		0,0,224,0,48,0,0,36,0,0,0,0,0,0,0,0,
		0,0,28,0,192,0,0,24,0,0,0,0,0,0,0,0,
		0,0,3,255,128,0,0,224,0,0,0,0,0,0,0,0,
		0,0,0,0,255,255,255,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
	ML_clear_vram();
	ML_bmp_or(introduction,0,1,128,63);
	ML_display_vram();
	Sleep(800);
	while(!IsKeyDown(KEY_CTRL_EXE));
}

void erreur(int handle){
	ML_clear_vram();
	locate(2,1);
	Print("Erreur...");
	locate(1,2);
	switch(handle){
		case IML_FILEERR_DEVICEFULL:
			Print("Memoire pleine");
			break;
		case IML_FILEERR_ILLEGALDEVICE:
			Print("Object illegal");
			break;
		case IML_FILEERR_ILLEGALSYSTEM:
			Print("Systme illegal");
			break;
		case IML_FILEERR_ACCESSDENYED:
			Print("Acces fichier refuse");
			break;
		case IML_FILEERR_ALREADYLOCKED:
			Print("Fichier verrouille");
			break;
		case IML_FILEERR_PERMISSIONERROR:
			Print("Erreur droits acces");
			break;
		case IML_FILEERR_ALREADYEXISTENTRY:
			Print("Fichier deja existant");
			break;
		case IML_FILEERR_READONLYFILE:
			Print("Fichier lecture seule");
			break;
		case IML_FILEERR_DEVICECHANGED:
			Print("Object change");
			break;
		case IML_FILEERR_RECORDNOTFOUND:
			Print("Fichier introuvable");
			break;
		case IML_FILEERR_DEVICEERROR:
			Print("Erreur systeme");
			break;
		case IML_FILEERR_DEVICENOTFOUND:
			Print("Object introuvable");
			break;
		case IML_FILEERR_COPYPROTECTION:
			Print("Fichier protege");
			break;
		case IML_FILEERR_ILLEGALFILEDATA:
			Print("Fichier illegal");
	}
}

void dessin(int mode){
	int i;
	const unsigned char lanceur1[] = {
		0,0,0,6,0,13,0,25,0,29,
		0,62,0,46,0,100,0,68,0,200,0,
		136,1,144,1,16,3,32,2,32,6,64,
		4,64,8,128,0,128,1,0 };
	const unsigned char lanceur1_mask[] = {
		255,255,255,255,255,255,255,255,253,255,255,249,255,255,253,255,
		255,255,255,255,239,255,255,231,255,255,199,255,255,207,255,255,
		143,255,255,159,255,255,31,255,255,63,255,254,63,255,254,127,
		255,252,127,255,248,255,255,240,255,255,249,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255 };
	const unsigned char lanceur2[] = {
		96,0,0,144,0,0,136,0,0,200,0,0,92,0,0,124,
		0,0,58,0,0,50,0,0,17,0,0,25,0,0,8,128,
		0,12,128,0,4,64,0,6,64,0,2,32,0,3,32,0,
		1,24,0,1,136,0,0,128,0,0,192,0,0,98,0,0,
		34,0,0,34,0,0,34,0,0,34,0,0,34,0,0,34,
		0,0,34,0,0,34,0,0,34,0,0,34,0,0,34,0,
		0,34,0,0,34,0,0,34,0,0,34,0,0,34,0,0,28,0 };
	const unsigned char lanceur2_mask[] = {
		255,255,255,159,255,255,143,255,255,207,255,255,223,255,255,255,
		255,255,251,255,255,243,255,255,241,255,255,249,255,255,248,255,
		255,252,255,255,252,127,255,254,127,255,254,63,255,255,63,255,
		255,31,255,255,143,255,255,135,255,255,195,255,255,227,255,255,
		227,255,255,227,255,255,227,255,255,227,255,255,227,255,255,227,
		255,255,227,255,255,227,255,255,227,255,255,227,255,255,227,255,
		255,227,255,255,227,255,255,227,255,255,227,255,255,227,255,255,255,255 };
	const unsigned char oiseau1[] = {
		2,128,5,64,4,56,8,4,16,2,23,58,32,193,162,17,
		96,193,225,49,98,9,162,197,33,53,16,202,8,4,7,248 };
	const unsigned char oiseau1_mask[] = {
		254,255,253,127,252,63,248,7,240,3,247,59,224,193,226,17,
		224,193,225,49,226,9,226,197,225,53,240,203,248,7,255,255 };
	const unsigned char oiseau2[] = {
		5,0,11,128,3,192,4,32,8,20,14,56,17,72,16,8,
		34,36,32,4,65,226,66,18,130,13,129,241,64,2,63,252 };
	const unsigned char oiseau2_mask[] = {
		255,255,255,255,255,255,252,63,248,31,254,63,241,79,240,15,
		226,39,224,7,193,227,194,19,130,13,129,241,192,3,255,255 };
	const unsigned char oiseau3[] = {
		2,128,1,128,31,248,63,252,111,250,113,198,254,191,251,239,
		255,255,254,63,252,15,252,231,124,30,126,62,63,252,15,240 };
	const unsigned char oiseau3_mask[] = {
		254,255,255,255,255,255,255,255,239,251,241,199,254,191,251,239,
		255,255,254,63,252,15,252,231,252,31,254,63,255,255,255,255 };
	const unsigned char oiseau4[] = {
		5,64,3,128,3,192,12,48,16,8,46,60,33,68,68,18,
		65,194,130,33,162,33,130,17,74,18,65,226,48,12,15,240 };
	const unsigned char oiseau4_mask[] = {
		255,255,255,255,255,255,252,63,240,15,238,63,225,71,196,19,
		193,195,130,33,162,33,130,17,202,19,193,227,240,15,255,255 };
	const unsigned char cochon1[] = {
		31,248,63,252,127,254,127,254,255,255,255,255,255,255,191,253,
		128,1,144,9,179,205,132,33,72,18,74,82,55,236,15,240 };
	const unsigned char cochon2_punched[] = {
		6,0,105,24,154,228,160,4,64,2,148,21,136,9,148,21,
		131,193,132,33,136,81,138,17,135,226,131,196,103,228,31,248 };
	const unsigned char cochon2[] = {
		49,128,74,64,86,176,32,12,64,2,144,25,179,201,132,33,
		136,81,138,17,135,225,131,193,71,226,71,226,48,12,15,240 };
	const unsigned char cochon1_punched[] = {
		7,224,31,248,47,228,71,206,243,238,255,254,255,255,159,249,
		168,21,144,9,168,21,131,193,132,34,72,82,58,20,15,248 };
	const unsigned char bloc1[] = { 126,193,161,193,161,213,171,126 };
	const unsigned char bloc1_punched[] = { 126,201,165,73,101,209,170,124 };
	const unsigned char bloc2[] = { 126,193,161,193,161,193,161,193,
		161,209,161,209,169,213,171,126 };
	const unsigned char bloc2_punched[] = {
		30,105,165,201,165,193,161,203,
		165,201,165,193,161,213,170,124 };
	const unsigned char bloc3[] = { 127,254,192,1,160,1,208,1,
		170,1,213,85,170,171,127,254 };
	const unsigned char bloc3_punched[] = { 
		31,30,100,225,194,21,164,41,
		208,1,170,169,117,86,31,252 };
	const unsigned char poutre1[] = {
		96,144,144,144,144,144,144,144,144,144,144,144,144,144,144,144,
		144,144,144,144,144,144,144,96 };
	const unsigned char poutre1_punched[] = {
		96,144,160,160,144,144,80,80,80,80,80,144,144,144,144,160,
		160,160,160,160,144,144,144,96 };
	const unsigned char poutre2[] = { 127,255,254,128,0,1,128,0,1,127,255,254 };
	const unsigned char poutre2_punched[] = { 126,7,230,129,248,25,156,1,193,99,254,62 };
	ML_clear_vram();
	if(mode){
		ML_line(23,31,32,31,ML_BLACK);
		ML_line(23,32,32,32,ML_BLACK);
		ML_line(40,30,32,31,ML_BLACK);
		ML_line(40,31,32,32,ML_BLACK);
	} else {
		ML_line(40,30,xo,yo,ML_BLACK);
		ML_line(40,31,xo,yo+1,ML_BLACK);
	}
	for(i=0;i<5;i++){
		switch(oiseaux[i]){
		case 1:
			ML_bmp_or(oiseau1,17*i,0,16,16);
			break;
		case 2:
			ML_bmp_or(oiseau2,17*i,0,16,16);
			break;
		case 3:
			ML_bmp_or(oiseau3,17*i,0,16,16);
			break;
		case 4:
			ML_bmp_or(oiseau4,17*i,0,16,16);
		}
	}
	for(i=0;i<3;i++){
		switch(cochons[i][0]){
		case 1:
			if(cochons[i][1]>4) ML_bmp_or_cl(cochon1,cochons[i][2],cochons[i][3],16,16);
			else ML_bmp_or_cl(cochon1_punched,cochons[i][2],cochons[i][3],16,16);
			break;
		case 2:
			if(cochons[i][1]>2) ML_bmp_or_cl(cochon2,cochons[i][2],cochons[i][3],16,16);
			else ML_bmp_or_cl(cochon2_punched,cochons[i][2],cochons[i][3],16,16);
		}
	}
	for(i=0;i<20;i++){
		switch(terrain[i][0]){
		case 1:
			if(terrain[i][1]>5) ML_bmp_8_or_cl(bloc1,terrain[i][2],terrain[i][3]);
			else ML_bmp_8_or_cl(bloc1_punched,terrain[i][2],terrain[i][3]);
			break;
		case 2:
			if(terrain[i][1]>7) ML_bmp_or_cl(bloc2,terrain[i][2],terrain[i][3],8,16);
			else ML_bmp_or_cl(bloc2_punched,terrain[i][2],terrain[i][3],8,16);
			break;
		case 3:
			if(terrain[i][1]>7) ML_bmp_or_cl(bloc3,terrain[i][2],terrain[i][3],16,8);
			else ML_bmp_or_cl(bloc3_punched,terrain[i][2],terrain[i][3],16,8);
			break;
		case 4:
			if(terrain[i][1]>3) ML_bmp_or_cl(poutre1,terrain[i][2],terrain[i][3],4,24);
			else ML_bmp_or_cl(poutre1_punched,terrain[i][2],terrain[i][3],4,24);
			break;
		case 5:
			if(terrain[i][1]>3) ML_bmp_or_cl(poutre2,terrain[i][2],terrain[i][3],24,4);
			else ML_bmp_or_cl(poutre2_punched,terrain[i][2],terrain[i][3],24,4);
			break;
		}
	}
	ML_bmp_and(lanceur1_mask,20,26,24,38);
	ML_bmp_or(lanceur1,28,26,16,20);
	if(mode!=2){
		switch(so){
		case 1:
			ML_bmp_and(oiseau1_mask,xo-7,yo-7,16,16);
			ML_bmp_or(oiseau1,xo-7,yo-7,16,16);
			break;
		case 2:
			ML_bmp_and(oiseau2_mask,xo-7,yo-7,16,16);
			ML_bmp_or(oiseau2,xo-7,yo-7,16,16);
			break;
		case 3:
			ML_bmp_and(oiseau3_mask,xo-7,yo-7,16,16);
			ML_bmp_or(oiseau3,xo-7,yo-7,16,16);
			break;
		case 4:
			ML_bmp_and(oiseau4_mask,xo-7,yo-7,16,16);
			ML_bmp_or(oiseau4,xo-7,yo-7,16,16);
			break;
		}
	}
	if(!mode){
		ML_line(23,31,xo-5,yo,ML_BLACK);
		ML_line(23,32,xo-5,yo+1,ML_BLACK);
	}
	ML_bmp_and(lanceur2_mask,20,26,24,38);
	ML_bmp_or(lanceur2,20,26,24,38);
	ML_display_vram();
}

int pause(){
	int i,j;
	int xc=42;
	int yc=24;
	const unsigned char pause[] = {
		0,0,0,0,3,255,255,255,255,255,248,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,60,8,33,31,31,4,0,0,0,0,0,
		0,0,0,0,4,126,28,97,191,191,132,0,0,0,0,0,
		0,0,0,0,4,103,54,97,177,184,4,0,0,0,0,0,
		0,0,0,0,4,99,99,97,176,48,4,0,0,0,0,0,
		0,0,0,0,4,103,99,97,184,60,4,0,0,0,0,0,
		0,0,0,0,4,126,127,97,159,60,4,0,0,0,0,0,
		0,0,0,0,4,124,127,97,143,176,4,0,0,0,0,0,
		0,0,0,0,4,96,99,97,129,176,4,0,0,0,0,0,
		0,0,0,0,4,96,99,115,177,184,4,0,0,0,0,0,
		0,0,0,0,4,96,99,63,63,191,132,0,0,0,0,0,
		0,0,0,0,4,32,34,30,31,31,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,7,255,255,255,248,4,0,0,0,0,0,
		0,0,0,0,4,3,255,255,255,240,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,15,255,128,31,255,4,0,0,0,0,0,
		0,0,0,0,4,16,0,64,32,0,132,0,0,0,0,0,
		0,0,0,0,4,32,0,32,64,0,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,76,6,68,0,0,0,0,0,
		0,0,0,0,4,35,254,32,78,14,68,0,0,0,0,0,
		0,0,0,0,4,34,2,32,71,28,68,0,0,0,0,0,
		0,0,0,0,4,34,66,32,67,184,68,0,0,0,0,0,
		0,0,0,0,4,34,98,32,65,240,68,0,0,0,0,0,
		0,0,0,0,4,47,242,32,64,224,68,0,0,0,0,0,
		0,0,0,0,4,34,98,32,65,240,68,0,0,0,0,0,
		0,0,0,0,4,34,66,32,67,184,68,0,0,0,0,0,
		0,0,0,0,4,34,2,32,71,28,68,0,0,0,0,0,
		0,0,0,0,4,35,254,32,78,14,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,76,6,68,0,0,0,0,0,
		0,0,0,0,4,16,0,64,32,0,132,0,0,0,0,0,
		0,0,0,0,4,15,255,128,31,255,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,15,255,128,31,255,4,0,0,0,0,0,
		0,0,0,0,4,16,0,64,32,0,132,0,0,0,0,0,
		0,0,0,0,4,32,0,32,65,248,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,67,252,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,71,28,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,78,12,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,76,62,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,76,30,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,76,28,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,76,8,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,78,0,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,71,6,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,67,254,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,65,252,68,0,0,0,0,0,
		0,0,0,0,4,16,0,64,32,0,132,0,0,0,0,0,
		0,0,0,0,4,15,255,128,31,255,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,3,255,255,255,255,255,248,0,0,0,0,0 };
	const unsigned char pausemask[]={
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,60,8,33,31,31,7,255,255,255,255,255,
		255,255,255,255,252,126,28,97,191,191,135,255,255,255,255,255,
		255,255,255,255,252,103,54,97,177,184,7,255,255,255,255,255,
		255,255,255,255,252,99,99,97,176,48,7,255,255,255,255,255,
		255,255,255,255,252,103,99,97,184,60,7,255,255,255,255,255,
		255,255,255,255,252,126,127,97,159,60,7,255,255,255,255,255,
		255,255,255,255,252,124,127,97,143,176,7,255,255,255,255,255,
		255,255,255,255,252,96,99,97,129,176,7,255,255,255,255,255,
		255,255,255,255,252,96,99,115,177,184,7,255,255,255,255,255,
		255,255,255,255,252,96,99,63,63,191,135,255,255,255,255,255,
		255,255,255,255,252,32,34,30,31,31,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,7,255,255,255,248,7,255,255,255,255,255,
		255,255,255,255,252,3,255,255,255,240,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,15,255,128,31,255,7,255,255,255,255,255,
		255,255,255,255,252,16,0,64,32,0,135,255,255,255,255,255,
		255,255,255,255,252,32,0,32,64,0,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,76,6,71,255,255,255,255,255,
		255,255,255,255,252,35,254,32,78,14,71,255,255,255,255,255,
		255,255,255,255,252,34,2,32,71,28,71,255,255,255,255,255,
		255,255,255,255,252,34,66,32,67,184,71,255,255,255,255,255,
		255,255,255,255,252,34,98,32,65,240,71,255,255,255,255,255,
		255,255,255,255,252,47,242,32,64,224,71,255,255,255,255,255,
		255,255,255,255,252,34,98,32,65,240,71,255,255,255,255,255,
		255,255,255,255,252,34,66,32,67,184,71,255,255,255,255,255,
		255,255,255,255,252,34,2,32,71,28,71,255,255,255,255,255,
		255,255,255,255,252,35,254,32,78,14,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,76,6,71,255,255,255,255,255,
		255,255,255,255,252,16,0,64,32,0,135,255,255,255,255,255,
		255,255,255,255,252,15,255,128,31,255,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,15,255,128,31,255,7,255,255,255,255,255,
		255,255,255,255,252,16,0,64,32,0,135,255,255,255,255,255,
		255,255,255,255,252,32,0,32,65,248,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,67,252,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,71,28,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,78,12,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,76,62,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,76,30,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,76,28,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,76,8,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,78,0,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,71,6,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,67,254,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,65,252,71,255,255,255,255,255,
		255,255,255,255,252,16,0,64,32,0,135,255,255,255,255,255,
		255,255,255,255,252,15,255,128,31,255,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255 };
	const unsigned char cache[] = {
		0,0,0,63,254,0,127,255,0,127,255,0,127,255,0,127,
		255,0,127,255,0,127,255,0,127,255,0,127,255,0,127,255,
		0,127,255,0,127,255,0,127,255,0,63,254,0,0,0,0 };
	do {
		ML_clear_vram();
		for(j=0;j<64;j++){
			for(i=0;i<128;i++){
				ML_pixel(i,j,ML_CHECKER);
			}
		}
		ML_bmp_and_cl(pausemask,0,0,128,64);
		ML_bmp_or_cl(pause,0,0,128,64);
		ML_bmp_xor(cache,xc,yc,17,16);
		ML_display_vram();
		while(IsKeyUp(KEY_CTRL_EXIT) && IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_LEFT) && IsKeyUp(KEY_CTRL_RIGHT) && IsKeyUp(KEY_CTRL_UP) && IsKeyUp(KEY_CTRL_DOWN));
		if(IsKeyDown(KEY_CTRL_EXIT)) return 0;
		if(IsKeyDown(KEY_CTRL_RIGHT) && xc<65) xc+=23;
		if(IsKeyDown(KEY_CTRL_LEFT) && xc>42) xc-=23;
		if(IsKeyDown(KEY_CTRL_DOWN) && yc<45) yc+=21;
		if(IsKeyDown(KEY_CTRL_UP) && yc>24) yc-=21;
	} while(IsKeyUp(KEY_CTRL_EXE));
	if(xc==65 && yc==24) return 0;
	else if(xc==42 && yc==45) return 1;
	else if(xc==65 && yc==45) return 2;
	else return 4;
}

int fin(int gagne){
	int curse=1;
	int i,j;
	int stars=0;
	const unsigned char won[] = {
		0,0,0,0,3,255,255,255,255,255,248,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,6,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,2,9,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,5,10,128,0,4,0,0,0,0,0,
		0,0,0,0,4,0,10,241,140,0,4,0,0,0,0,0,
		0,0,0,0,4,0,9,0,114,0,4,0,0,0,0,0,
		0,0,0,0,4,0,4,1,2,0,4,0,0,0,0,0,
		0,0,0,0,4,0,8,193,132,0,4,0,0,0,0,0,
		0,0,0,0,4,0,17,128,130,0,4,0,0,0,0,0,
		0,0,0,0,4,0,32,0,1,0,4,0,0,0,0,0,
		0,0,0,0,4,0,32,126,1,0,4,0,0,0,0,0,
		0,0,0,0,4,0,32,129,0,128,4,0,0,0,0,0,
		0,0,0,0,4,0,93,0,156,128,4,0,0,0,0,0,
		0,0,0,0,4,0,98,0,190,128,4,0,0,0,0,0,
		0,0,0,0,4,0,66,6,190,128,4,0,0,0,0,0,
		0,0,0,0,4,0,90,102,188,128,4,0,0,0,0,0,
		0,0,0,0,4,0,114,96,156,128,4,0,0,0,0,0,
		0,0,0,0,4,0,93,0,128,128,4,0,0,0,0,0,
		0,0,0,0,4,0,64,255,0,128,4,0,0,0,0,0,
		0,0,0,0,4,0,32,0,0,128,4,0,0,0,0,0,
		0,0,0,0,4,0,32,63,1,0,4,0,0,0,0,0,
		0,0,0,0,4,0,24,64,130,0,4,0,0,0,0,0,
		0,0,0,0,4,0,4,127,140,0,4,0,0,0,0,0,
		0,0,0,0,4,0,3,128,112,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,127,128,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,15,255,128,31,255,4,0,0,0,0,0,
		0,0,0,0,4,16,0,64,32,0,132,0,0,0,0,0,
		0,0,0,0,4,32,0,32,64,0,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,71,0,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,68,192,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,68,48,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,68,8,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,68,4,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,68,6,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,68,12,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,68,56,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,68,240,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,71,192,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,71,0,68,0,0,0,0,0,
		0,0,0,0,4,16,0,64,32,0,132,0,0,0,0,0,
		0,0,0,0,4,15,255,128,31,255,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,3,255,255,255,255,255,248,0,0,0,0,0 };
	const unsigned char failed[] = {
		0,0,0,0,3,255,255,255,255,255,248,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,6,4,0,0,0,0,0,
		0,0,0,0,4,241,247,143,16,134,4,0,0,0,0,0,
		0,0,0,0,4,137,4,72,144,134,4,0,0,0,0,0,
		0,0,0,0,4,133,4,40,80,134,4,0,0,0,0,0,
		0,0,0,0,4,133,4,40,80,134,4,0,0,0,0,0,
		0,0,0,0,4,137,196,72,80,134,4,0,0,0,0,0,
		0,0,0,0,4,241,7,136,80,134,4,0,0,0,0,0,
		0,0,0,0,4,129,4,136,80,134,4,0,0,0,0,0,
		0,0,0,0,4,129,4,72,145,134,4,0,0,0,0,0,
		0,0,0,0,4,129,244,47,14,128,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,6,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,6,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,7,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,6,8,128,0,4,0,0,0,0,0,
		0,0,0,0,4,0,9,10,128,0,4,0,0,0,0,0,
		0,0,0,0,4,0,10,241,128,0,4,0,0,0,0,0,
		0,0,0,0,4,0,9,0,96,0,4,0,0,0,0,0,
		0,0,0,0,4,0,4,0,24,0,4,0,0,0,0,0,
		0,0,0,0,4,0,8,0,4,0,4,0,0,0,0,0,
		0,0,0,0,4,0,16,0,2,0,4,0,0,0,0,0,
		0,0,0,0,4,0,32,0,1,0,4,0,0,0,0,0,
		0,0,0,0,4,0,32,126,1,0,4,0,0,0,0,0,
		0,0,0,0,4,0,32,129,0,128,4,0,0,0,0,0,
		0,0,0,0,4,0,93,0,158,128,4,0,0,0,0,0,
		0,0,0,0,4,0,98,0,161,128,4,0,0,0,0,0,
		0,0,0,0,4,0,82,6,165,128,4,0,0,0,0,0,
		0,0,0,0,4,0,90,102,173,128,4,0,0,0,0,0,
		0,0,0,0,4,0,98,96,162,128,4,0,0,0,0,0,
		0,0,0,0,4,0,93,0,156,128,4,0,0,0,0,0,
		0,0,0,0,4,0,64,255,0,128,4,0,0,0,0,0,
		0,0,0,0,4,0,32,0,0,128,4,0,0,0,0,0,
		0,0,0,0,4,0,32,255,129,0,4,0,0,0,0,0,
		0,0,0,0,4,0,24,64,130,0,4,0,0,0,0,0,
		0,0,0,0,4,0,4,63,12,0,4,0,0,0,0,0,
		0,0,0,0,4,0,3,128,112,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,127,128,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,15,255,128,31,255,4,0,0,0,0,0,
		0,0,0,0,4,16,0,64,32,0,132,0,0,0,0,0,
		0,0,0,0,4,32,0,32,65,248,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,67,252,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,71,28,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,78,12,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,76,62,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,76,30,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,76,28,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,76,8,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,78,0,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,71,6,68,0,0,0,0,0,
		0,0,0,0,4,35,62,32,67,254,68,0,0,0,0,0,
		0,0,0,0,4,32,0,32,65,252,68,0,0,0,0,0,
		0,0,0,0,4,16,0,64,32,0,132,0,0,0,0,0,
		0,0,0,0,4,15,255,128,31,255,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,4,0,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,3,255,255,255,255,255,248,0,0,0,0,0 };
	const unsigned char failedmask[] = {
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,6,7,255,255,255,255,255,
		255,255,255,255,252,241,247,143,16,134,7,255,255,255,255,255,
		255,255,255,255,252,137,4,72,144,134,7,255,255,255,255,255,
		255,255,255,255,252,133,4,40,80,134,7,255,255,255,255,255,
		255,255,255,255,252,133,4,40,80,134,7,255,255,255,255,255,
		255,255,255,255,252,137,196,72,80,134,7,255,255,255,255,255,
		255,255,255,255,252,241,7,136,80,134,7,255,255,255,255,255,
		255,255,255,255,252,129,4,136,80,134,7,255,255,255,255,255,
		255,255,255,255,252,129,4,72,145,134,7,255,255,255,255,255,
		255,255,255,255,252,129,244,47,14,128,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,6,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,6,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,7,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,6,8,128,0,7,255,255,255,255,255,
		255,255,255,255,252,0,9,10,128,0,7,255,255,255,255,255,
		255,255,255,255,252,0,10,241,128,0,7,255,255,255,255,255,
		255,255,255,255,252,0,9,0,96,0,7,255,255,255,255,255,
		255,255,255,255,252,0,4,0,24,0,7,255,255,255,255,255,
		255,255,255,255,252,0,8,0,4,0,7,255,255,255,255,255,
		255,255,255,255,252,0,16,0,2,0,7,255,255,255,255,255,
		255,255,255,255,252,0,32,0,1,0,7,255,255,255,255,255,
		255,255,255,255,252,0,32,126,1,0,7,255,255,255,255,255,
		255,255,255,255,252,0,32,129,0,128,7,255,255,255,255,255,
		255,255,255,255,252,0,93,0,158,128,7,255,255,255,255,255,
		255,255,255,255,252,0,98,0,161,128,7,255,255,255,255,255,
		255,255,255,255,252,0,82,6,165,128,7,255,255,255,255,255,
		255,255,255,255,252,0,90,102,173,128,7,255,255,255,255,255,
		255,255,255,255,252,0,98,96,162,128,7,255,255,255,255,255,
		255,255,255,255,252,0,93,0,156,128,7,255,255,255,255,255,
		255,255,255,255,252,0,64,255,0,128,7,255,255,255,255,255,
		255,255,255,255,252,0,32,0,0,128,7,255,255,255,255,255,
		255,255,255,255,252,0,32,255,129,0,7,255,255,255,255,255,
		255,255,255,255,252,0,24,64,130,0,7,255,255,255,255,255,
		255,255,255,255,252,0,4,63,12,0,7,255,255,255,255,255,
		255,255,255,255,252,0,3,128,112,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,127,128,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,15,255,128,31,255,7,255,255,255,255,255,
		255,255,255,255,252,16,0,64,32,0,135,255,255,255,255,255,
		255,255,255,255,252,32,0,32,65,248,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,67,252,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,71,28,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,78,12,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,76,62,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,76,30,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,76,28,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,76,8,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,78,0,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,71,6,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,67,254,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,65,252,71,255,255,255,255,255,
		255,255,255,255,252,16,0,64,32,0,135,255,255,255,255,255,
		255,255,255,255,252,15,255,128,31,255,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255 };
	const unsigned char wonmask[] = {
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,6,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,2,9,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,5,10,128,0,7,255,255,255,255,255,
		255,255,255,255,252,0,10,241,140,0,7,255,255,255,255,255,
		255,255,255,255,252,0,9,0,114,0,7,255,255,255,255,255,
		255,255,255,255,252,0,4,1,2,0,7,255,255,255,255,255,
		255,255,255,255,252,0,8,193,132,0,7,255,255,255,255,255,
		255,255,255,255,252,0,17,128,130,0,7,255,255,255,255,255,
		255,255,255,255,252,0,32,0,1,0,7,255,255,255,255,255,
		255,255,255,255,252,0,32,126,1,0,7,255,255,255,255,255,
		255,255,255,255,252,0,32,129,0,128,7,255,255,255,255,255,
		255,255,255,255,252,0,93,0,156,128,7,255,255,255,255,255,
		255,255,255,255,252,0,98,0,190,128,7,255,255,255,255,255,
		255,255,255,255,252,0,66,6,190,128,7,255,255,255,255,255,
		255,255,255,255,252,0,90,102,188,128,7,255,255,255,255,255,
		255,255,255,255,252,0,114,96,156,128,7,255,255,255,255,255,
		255,255,255,255,252,0,93,0,128,128,7,255,255,255,255,255,
		255,255,255,255,252,0,64,255,0,128,7,255,255,255,255,255,
		255,255,255,255,252,0,32,0,0,128,7,255,255,255,255,255,
		255,255,255,255,252,0,32,63,1,0,7,255,255,255,255,255,
		255,255,255,255,252,0,24,64,130,0,7,255,255,255,255,255,
		255,255,255,255,252,0,4,127,140,0,7,255,255,255,255,255,
		255,255,255,255,252,0,3,128,112,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,127,128,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,15,255,128,31,255,7,255,255,255,255,255,
		255,255,255,255,252,16,0,64,32,0,135,255,255,255,255,255,
		255,255,255,255,252,32,0,32,64,0,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,71,0,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,68,192,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,68,48,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,68,8,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,68,4,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,68,6,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,68,12,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,68,56,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,68,240,71,255,255,255,255,255,
		255,255,255,255,252,35,62,32,71,192,71,255,255,255,255,255,
		255,255,255,255,252,32,0,32,71,0,71,255,255,255,255,255,
		255,255,255,255,252,16,0,64,32,0,135,255,255,255,255,255,
		255,255,255,255,252,15,255,128,31,255,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,252,0,0,0,0,0,7,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255 };
	const unsigned char cache[] = {
		0,0,0,63,254,0,127,255,0,127,255,0,127,255,0,127,
		255,0,127,255,0,127,255,0,127,255,0,127,255,0,127,255,
		0,127,255,0,127,255,0,127,255,0,63,254,0,0,0,0 };
	unsigned char etoile[] = {
		2,0,2,0,5,0,5,0,101,48,152,200,64,16,32,32,
		16,64,18,64,37,32,40,160,16,64 };
	if(gagne){
		if(score>Q3) stars=3;
		else if(score>Q1) stars=2;
		else stars=1;
		if(stars==1 && enregistrement[niveau]=='B') enregistrement[niveau]='C';
		if(stars==2 && enregistrement[niveau]!='E') enregistrement[niveau]='D';
		if(stars==3) enregistrement[niveau]='E';
		if(niveau<TAILLE-2) if(enregistrement[niveau+1]=='A') enregistrement[niveau+1]='B';
		do{
			ML_clear_vram();
			for(j=0;j<64;j++){
				for(i=0;i<128;i++){
					ML_pixel(i,j,ML_CHECKER);
				}
			}
			ML_bmp_and(wonmask,0,0,128,64);
			ML_bmp_or(won,0,0,128,64);
			if(curse==1) ML_bmp_xor(cache,42,45,17,16);
			if(curse==3) ML_bmp_xor(cache,65,45,17,16);
			ML_bmp_or(etoile,39,2,13,13);
			if(stars>1) ML_bmp_or(etoile,54,2,13,13);
			if(stars>2) ML_bmp_or(etoile,68,2,13,13);
			ML_display_vram();
			while(IsKeyUp(KEY_CTRL_EXIT) && IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_LEFT) && IsKeyUp(KEY_CTRL_RIGHT));
			if(IsKeyDown(KEY_CTRL_LEFT)) curse=1;
			if(IsKeyDown(KEY_CTRL_RIGHT)) curse=3;
			if(IsKeyDown(KEY_CTRL_EXIT)) return 0;
		} while(IsKeyUp(KEY_CTRL_EXE));
	} else {
		do{
			ML_clear_vram();
			for(j=0;j<64;j++){
				for(i=0;i<128;i++){
					ML_pixel(i,j,ML_CHECKER);
				}
			}
			ML_bmp_and(failedmask,0,0,128,64);
			ML_bmp_or(failed,0,0,128,64);
			if(curse==1) ML_bmp_xor(cache,42,45,17,16);
			if(curse==2) ML_bmp_xor(cache,65,45,17,16);
			ML_display_vram();
			while(IsKeyUp(KEY_CTRL_EXIT) && IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_LEFT) && IsKeyUp(KEY_CTRL_RIGHT));
			if(IsKeyDown(KEY_CTRL_LEFT)) curse=1;
			if(IsKeyDown(KEY_CTRL_RIGHT)) curse=2;
			if(IsKeyDown(KEY_CTRL_EXIT)) return 0;
		} while(IsKeyUp(KEY_CTRL_EXE));
	}
	return curse;
}

int IsCollision(){
	int larg;
	int haut;
	for(int i=0;i<20;i++){
		if(terrain[i][0]){
			switch(terrain[i][0]){
			case 1:
				larg=7;
				haut=7;
				break;
			case 2:
				larg=7;
				haut=15;
				break;
			case 3:
				larg=15;
				haut=7;
				break;
			case 4:
				larg=3;
				haut=23;
				break;
			case 5:
				larg=23;
				haut=3;
				break;
			}
			if(xo+8>terrain[i][2] && xo-7<terrain[i][2]+larg && yo+8>terrain[i][3] && yo-7<terrain[i][3]+haut) return 1;
		}
	}
	for(int i=0;i<3;i++){
		if(cochons[i][0]){
			if(xo+8>cochons[i][2] && xo-7<cochons[i][2]+15 && yo+8>cochons[i][3] && yo-7<cochons[i][3]+15) return 1;
		}
	}
	if(xo>23 && xo<41 && yo>40) return 2;
	if(yo>56||xo>135) return 2;
	return 0;
}

int collision(){
	int larg,haut,i,j;
	int reco=0;
	int malus;
	malus=0;
	for(i=0;i<20;i++){
		if(terrain[i][0]){
			switch(terrain[i][0]){
			case 1:
				larg=7;
				haut=7;
				break;
			case 2:
				larg=7;
				haut=15;
				break;
			case 3:
				larg=15;
				haut=7;
				break;
			case 4:
				larg=3;
				haut=23;
				break;
			case 5:
				larg=23;
				haut=3;
				break;
			}
			if(xo+8>terrain[i][2] && xo-7<terrain[i][2]+larg && yo+8>terrain[i][3] && yo-7<terrain[i][3]+haut) {
				malus+=terrain[i][1];
				score+=200*terrain[i][1];
				terrain[i][1]-=force/5;
				if(terrain[i][1]<1) for(j=0;j<4;j++) terrain[i][j]=0;
				else reco=1;
			}
		}
	}
	for(i=0;i<3;i++){
		if(cochons[i][0]){
			if(xo+8>cochons[i][2] && xo-7<cochons[i][2]+15 && yo+8>cochons[i][3] && yo-7<cochons[i][3]+15) {
				malus+=cochons[i][1];
				cochons[i][1]-=force/5;
				if(cochons[i][1]<1) {
					for(j=0;j<4;j++) cochons[i][j]=0;
					score+=5000;
				}
				else reco=1;
			}
		}
	}
	force-=malus;
	return reco;
}

void gravite(){
	if(niveau==1 && !terrain[7][0]){
		for(terrain[6][3]=20;terrain[6][3]<40;terrain[6][3]++){
			Sleep(7);
			dessin(2);
		}
		for(int j=0;j<4;j++) cochons[0][j]=0;
		score+=5000;
	}
	if(niveau==3 && cochons[0][0] && !terrain[6][0]){
		for(cochons[0][3]=28;cochons[0][3]<=33;cochons[0][3]++){
			Sleep(7);
			dessin(2);
		}
		for(int j=0;j<4;j++) cochons[0][j]=0;
		for(int j=0;j<4;j++) cochons[1][j]=0;
		score+=10000;
	}
	if(niveau==5 && !terrain[9][0]){
		for(terrain[2][3]==24;terrain[2][3]<32;terrain[2][3]++){
			Sleep(3);
			dessin(2);
		}
		score+=200*terrain[2][1];
		for(int j=0;j<4;j++) terrain[2][j]=0;
	}
	if(niveau==11 && !terrain[2][0]){
		for(int i=0;i<22;i++){
			Sleep(7);
			dessin(2);
			if(terrain[3][0]) terrain[3][3]++;
			if(terrain[4][0]) terrain[4][3]++;
		}
		if(terrain[3][0]){
			for(int j=0;j<4;j++) cochons[0][j]=0;
			score+=5000;
		}
		if(terrain[4][0]){
			for(int j=0;j<4;j++) cochons[1][j]=0;
			score+=5000;
		}
	}
	if(niveau==12 && !terrain[6][0]){
		for(terrain[7][3]=4;terrain[7][3]<40;terrain[7][3]++){
			Sleep(5);
			dessin(2);
		}
		for(int j=0;j<4;j++) cochons[0][j]=0;
		score+=5000;
	}
}

void explosion(){
	int r;
	int larg,haut,i,j;
	for(r=6;r<=20;r++){
		Sleep(11);
		dessin(2);
		ML_filled_circle(xo,yo,r,ML_BLACK);
		ML_display_vram();
	}
	for(i=0;i<20;i++){
		if(terrain[i][0]){
			switch(terrain[i][0]){
			case 1:
				larg=7;
				haut=7;
				break;
			case 2:
				larg=7;
				haut=15;
				break;
			case 3:
				larg=15;
				haut=7;
				break;
			case 4:
				larg=3;
				haut=23;
				break;
			case 5:
				larg=23;
				haut=3;
				break;
			}
			if(sqrt((terrain[i][2]-xo)*(terrain[i][2]-xo)+(terrain[i][3]-yo)*(terrain[i][3]-yo))<=r
			|| sqrt((terrain[i][2]+larg-xo)*(terrain[i][2]+larg-xo)+(terrain[i][3]+haut-yo)*(terrain[i][3]+haut-yo))<=r){
				score+=200*terrain[i][1];
				terrain[i][1]-=7;
				if(terrain[i][1]<1) for(j=0;j<4;j++) terrain[i][j]=0;
			}
		}
	}
	for(i=0;i<3;i++){
		if(cochons[i][0]){
			if(sqrt((cochons[i][2]-xo)*(cochons[i][2]-xo)+(cochons[i][3]-yo)*(cochons[i][3]-yo))<=r
			|| sqrt((cochons[i][2]+15-xo)*(cochons[i][2]+15-xo)+(cochons[i][3]+15-yo)*(cochons[i][3]+15-yo))<=r){
				cochons[i][1]-=7;
				if(cochons[i][1]<1) {
					for(j=0;j<4;j++) cochons[i][j]=0;
					score+=5000;
				}
			}
		}
	}
}

int jeu(){
	int i=4;
	int clic;
	double dx,dy,grav;
	int fini=0;
	int coll,pau;
	score=0;
	do {
		if(!oiseaux[i]) i--;
		else {
			xo=31;
			yo=31;
			so=oiseaux[i];
			oiseaux[i]=0;
			do {
				clic=0;
				dessin(0);
				while(IsKeyUp(KEY_CTRL_MENU) && IsKeyUp(KEY_CTRL_EXIT) && IsKeyUp(KEY_CTRL_UP) && IsKeyUp(KEY_CTRL_DOWN) && IsKeyUp(KEY_CTRL_RIGHT) && IsKeyUp(KEY_CTRL_LEFT) && IsKeyUp(KEY_CTRL_SHIFT));
				if(IsKeyDown(KEY_CTRL_EXIT)) return 0;
				if(IsKeyDown(KEY_CTRL_MENU)){
					pau=pause();
					if(pau<4) return pau;
				}
				if(IsKeyDown(KEY_CTRL_UP) && yo>24) yo--;
				if(IsKeyDown(KEY_CTRL_DOWN) && yo<49 && !(xo>21 && yo>32)) yo++;
				if(IsKeyDown(KEY_CTRL_LEFT) && xo>10) xo--;
				if(IsKeyDown(KEY_CTRL_RIGHT) && ((xo<31 && yo<34) || (xo<21 && yo>33))) xo++;
			} while(IsKeyUp(KEY_CTRL_SHIFT)||xo>28);
			force = sqrt((31-xo)*(31-xo)+(31-yo)*(31-yo));
			dx=(31-xo)/5;
			dy=(yo-31)/5;
			grav=0.15;
			do {
				Sleep(40);
				xo+=dx;
				yo-=dy;
				dy-=grav;
				if(xo>31) dessin(1);
				else dessin(0);
				if(IsKeyDown(KEY_CTRL_EXIT)) return 0;
				if(IsKeyDown(KEY_CTRL_EXE) && clic==0) {
					if(so==2) {
						grav=0;
						dx*=1.5;
						force*=1.2;
						clic=1;
					}
					if(so==3){
						clic=1;
						explosion();
						break;
					}
				}
				if(IsKeyDown(KEY_CTRL_MENU)) {
					pau=pause();
					if(pau<4) return pau;
				}
				coll=IsCollision();
				if(coll==1) coll=collision();
			} while(!coll);
			if(so==3 && clic==0) explosion();
			gravite();
			fini=1;
			for(int j=0;j<3;j++) if(cochons[j][0]) fini=0;
		}
	} while(IsKeyUp(KEY_CTRL_EXIT) && oiseaux[0] && !fini);
	for(int j=0;j<5;j++) if(oiseaux[j]) score+=10000;
	return fin(fini);
}

int generer() {
	int i,j;
	if(niveau==0){
		const int O[5] = {1,1,0,0,0};
		const int C[3][4] = {{1,5,92,20},{0,0,0,0},{0,0,0,0}};
		const int T[20][4] = {{2,10,79,48},{2,10,113,48},{4,6,87,12},{4,8,87,40},{4,8,109,12},{4,8,109,40},{5,6,88,36},
			{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=6000;
		Q3=8000;
	}
	else if(niveau==1){
		const int O[5] = {2,2,0,0,0};
		const int C[3][4] = {{1,6,91,48},{0,0,0,0},{0,0,0,0}};
		const int T[20][4] = {{2,10,74,48},{2,10,82,48},{2,12,82,32},{2,10,108,48},{2,10,116,48},{2,12,108,32},{3,12,91,20},{5,4,87,28},
			{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=8000;
		Q3=17000;
	}
	else if(niveau==2){
		const int O[5] = {1,3,0,0,0};
		const int C[3][4] = {{2,8,85,48},{1,6,85,24},{0,0,0,0}};
		const int T[20][4] = {{1,8,68,48},{1,8,68,56},{1,8,110,48},{1,8,110,56},{2,10,76,48},{2,10,102,48},{3,10,77,40},{3,10,93,40},
			{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=10000;
		Q3=17000;
	}
	else if(niveau==3){
		const int O[5] = {1,2,2,0,0};
		const int C[3][4] = {{2,8,94,28},{2,6,94,48},{0,0,0,0}};
		const int T[20][4] = {{4,4,82,40},{4,4,86,24},{4,4,90,20},{4,4,110,20},{4,4,114,24},{4,4,118,40},{5,5,90,44},{2,12,86,48},
			{2,12,110,48},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=18000;
		Q3=27000;
	}
	else if(niveau==4){
		const int O[5] = {3,3,0,0,0};
		const int C[3][4] = {{2,9,96,24},{2,9,96,48},{0,0,0,0}};
		const int T[20][4] = {{3,10,88,16},{3,15,88,40},{3,10,104,16},{3,15,104,40},{2,10,87,24},{2,15,87,48},{2,10,113,24},{2,15,113,48},
			{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=17000;
		Q3=26000;
	}
	else if(niveau==5){
		const int O[5] = {3,3,3,0,0};
		const int C[3][4] = {{1,9,92,24},{1,9,92,48},{0,0,0,0}};
		const int T[20][4] = {{2,13,76,32},{2,15,76,48},{2,15,84,24},{2,15,84,48},{2,15,108,24},{2,15,108,48},{2,13,116,32},{2,15,116,48},
			{3,13,84,16},{3,15,84,40},{3,13,100,16},{3,15,100,40},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=30000;
		Q3=38000;
	}
	else if(niveau==6){
		const int O[5] = {2,1,0,0,0};
		const int C[3][4] = {{1,5,106,40},{0,0,0,0},{0,0,0,0}};
		const int T[20][4] = {{4,5,78,24},{2,8,82,32},{3,12,74,48},{3,12,74,56},{3,12,90,56},{3,12,106,56},{0,0,0,0},{0,0,0,0},
			{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=6000;
		Q3=13000;
	}
	else if(niveau==7){
		const int O[5] = {2,2,2,2,0};
		const int C[3][4] = {{1,9,77,48},{1,10,89,28},{1,9,101,48}};
		const int T[20][4] = {{2,10,69,48},{2,10,93,48},{2,10,117,48},{4,4,69,24},{4,4,121,24},{5,4,73,44},{5,4,97,44},{0,0,0,0},
			{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=24000;
		Q3=32000;
	}
	else if(niveau==8){
		const int O[5] = {3,3,0,0,0};
		const int C[3][4] = {{1,11,78,16},{1,11,102,16},{2,9,90,40}};
		const int T[20][4] = {{2,15,73,48},{2,15,115,48},{2,15,81,32},{2,15,107,32},{1,16,81,48},{1,16,107,48},{3,18,82,56},{3,18,98,56},
			{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=24000;
		Q3=32000;
	}
	else if(niveau==9){
		const int O[5] = {1,1,0,0,0};
		const int C[3][4] = {{1,5,71,32},{1,5,89,32},{1,5,107,32}};
		const int T[20][4] = {{2,17,75,48},{2,17,93,48},{2,17,111,48},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
			{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=16000;
		Q3=24000;
	}
	else if(niveau==10){
		const int O[5] = {1,1,2,0,0};
		const int C[3][4]= {{1,6,69,40},{1,6,85,24},{1,5,102,8}};
		const int T[20][4] = {{1,16,70,56},{1,16,86,40},{3,16,78,56},{3,16,86,48},{3,16,94,40},{3,16,102,32},{3,16,102,24},{4,14,114,40},
			{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=18000;
		Q3=30000;
	}
	else if(niveau==11){
		const int O[5] = {1,2,0,0,0};
		const int C[3][4] = {{2,12,76,48},{2,12,102,48},{0,0,0,0}};
		const int T[20][4] = {{2,15,93,48},{2,15,93,32},{5,4,85,28},{1,16,83,20},{1,16,103,20},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},
			{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=16000;
		Q3=24000;
	}
	else if(niveau==12){
		const int O[5] = {1,2,0,0,0};
		const int C[3][4] = {{1,8,91,48},{0,0,0,0},{0,0,0,0}};
		const int T[20][4] = {{2,13,82,16},{2,13,82,32},{2,13,82,48},{2,13,108,16},{2,13,108,32},{2,13,108,48},{5,5,87,12},{1,15,95,4},{0,0,0,0},
			{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=6000;
		Q3=15000;
	}
	else if(niveau==13){
		const int O[5] = {1,2,0,0,0};
		const int C[3][4] = {{2,6,107,40},{0,0,0,0},{0,0,0,0}};
		const int T[20][4] = {{1,9,60,56},{1,9,76,40},{1,7,84,32},{1,9,84,56},{3,13,68,48},{3,13,68,56},{3,15,92,56},{2,13,84,40},{3,13,108,56},
			{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=6000;
		Q3=15000;
	}
	else if(niveau==14){
		const int O[5] = {3,0,0,0,0};
		const int C[3][4] = {{1,7,100,8},{0,0,0,0},{0,0,0,0}};
		const int T[20][4] = {{2,13,72,48},{2,11,88,0},{2,13,120,0},{2,8,80,16},{2,11,88,16},{2,13,80,32},{2,13,88,32},{2,13,96,32},{2,13,104,32},{2,13,112,32},
			{2,13,120,32},{2,13,80,48},{2,13,88,48},{2,13,96,48},{2,13,104,48},{2,13,112,48},{2,13,120,48},{3,13,96,24},{3,13,112,24},{1,13,120,16}};
		for(i=0;i<5;i++){
			oiseaux[i] = O[i];
		}
		for(i=0;i<3;i++){
			for(j=0;j<4;j++){
				cochons[i][j] = C[i][j];
			}
		}
		for(i=0;i<20;i++){
			for(j=0;j<4;j++){
				terrain[i][j] = T[i][j];
			}
		}
		Q1=8000;
		Q3=16000;
	}
	//else if(niveau==){
	//	const int O[5];
	//	const int C[3][4];
	//	const int T[20][4];
	//	for(i=0;i<5;i++){
	//		oiseaux[i] = O[i];
	//	}
	//	for(i=0;i<3;i++){
	//		for(j=0;j<4;j++){
	//			cochons[i][j] = C[i][j];
	//		}
	//	}
	//	for(i=0;i<20;i++){
	//		for(j=0;j<4;j++){
	//			terrain[i][j] = T[i][j];
	//		}
	//	}
	//}
	return jeu();
}


int menu(){
	unsigned char menu[] = {
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,239,255,255,255,255,255,255,255,255,255,
		255,255,255,255,254,255,255,254,255,255,255,255,240,15,255,255,
		255,255,255,247,255,255,255,255,255,223,255,255,224,7,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,227,195,255,255,
		255,255,239,255,255,255,255,255,255,255,247,255,227,227,255,255,
		249,255,255,255,255,255,255,255,255,255,255,255,227,243,255,255,
		246,249,255,255,255,255,255,255,255,255,255,255,227,243,255,255,
		246,246,255,255,255,255,255,255,255,255,255,253,227,227,255,255,
		247,118,255,255,255,255,255,255,255,255,255,255,224,7,255,255,
		251,109,255,255,255,255,255,255,255,255,255,255,224,14,15,255,
		251,173,255,255,255,255,255,255,255,255,255,255,227,252,3,255,
		253,171,255,255,255,255,255,255,255,255,255,255,227,248,243,255,
		253,219,255,255,255,255,255,255,255,255,255,255,227,249,255,255,
		254,247,255,255,255,255,255,255,255,255,255,255,227,249,255,255,
		254,247,255,255,255,255,255,255,255,255,255,255,227,249,255,255,
		255,111,255,255,255,255,255,255,255,255,255,255,243,249,255,255,
		255,111,255,255,255,255,255,255,255,255,255,255,255,248,243,255,
		255,111,255,255,255,255,255,255,255,255,255,255,255,248,3,255,
		255,111,255,255,255,255,255,255,255,255,255,255,255,252,7,255,
		255,111,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,111,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		131,104,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		8,186,47,17,16,0,0,0,0,0,0,0,0,0,0,0,
		8,146,40,41,16,0,0,0,0,0,0,0,0,0,0,0,
		12,146,40,69,16,0,0,0,0,0,0,0,0,0,0,0,
		10,146,46,69,16,0,0,0,0,0,0,0,0,0,0,0,
		9,146,40,125,16,0,0,0,0,0,0,0,0,0,0,0,
		8,145,72,69,16,0,0,0,0,0,0,0,0,0,0,0,
		8,184,143,68,224,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,175,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,7,255,255,255,255,255,255,255,255,255,255,255,249,255,255,
		255,143,255,255,255,255,255,255,255,255,255,255,254,118,255,255,
		255,183,255,255,255,255,255,255,255,255,255,255,253,178,255,255,
		255,123,255,255,255,255,255,255,255,255,255,255,253,75,3,255,
		254,253,255,255,255,255,255,255,255,255,255,255,254,191,253,255,
		248,254,63,255,255,255,255,255,255,255,255,255,253,255,254,255,
		253,16,255,255,255,255,255,255,255,255,255,255,253,159,206,255,
		251,255,127,255,255,255,255,255,255,255,255,255,251,239,191,127,
		251,187,127,255,255,255,255,255,255,255,255,255,251,255,207,127,
		247,255,191,255,255,255,255,255,255,255,255,255,251,159,143,127,
		247,199,191,255,255,255,255,255,255,255,255,255,251,31,255,127,
		239,184,223,255,255,255,255,255,255,255,255,255,251,240,127,127,
		239,127,95,255,255,255,255,255,255,255,255,255,251,239,191,127,
		223,184,239,255,255,255,255,255,255,255,255,255,251,222,95,127,
		223,199,239,255,255,255,255,255,255,255,255,255,251,210,95,127,
		231,255,159,255,255,255,255,255,255,255,255,255,251,211,223,127,
		248,0,127,255,255,255,255,255,255,255,255,255,253,224,62,255 };
	unsigned char verrou[] = {
		7,0,15,128,24,192,24,192,127,240,255,248,253,248,248,248,
		248,248,253,248,253,248,255,248,127,240 };
	unsigned char etoile[] = {
		2,0,2,0,5,0,5,0,101,48,152,200,64,16,32,32,
		16,64,18,64,37,32,40,160,16,64 };
	unsigned char haut[] = { 16,16,56,56,124,124,254,254 };
	unsigned char bas[] = { 254,254,124,124,56,56,16,16 };
	unsigned char chaine[3];
	int handle, reussite;
	const FONTCHARACTER fichier[] = {'\\','\\','f','l','s','0','\\','a','n','g','b','i','r','d','s','.','t','x','t',0};
	handle = Bfile_OpenFile(fichier,_OPENMODE_READ);
	ML_clear_vram();
	if(handle<0){
		enregistrement[0]='B';
		for(int k=1;k<TAILLE-1;k++) enregistrement[k]='A';
	} else Bfile_ReadFile(handle,enregistrement,TAILLE-1,0);
	niveau=0;
	do {
		reussite=0;
		Sleep(100);
		do {
			ML_clear_vram();
			ML_bmp_or(menu,0,0,128,64);
			if(niveau>0) ML_bmp_xor(haut,59,13,7,8);
			if(niveau<TAILLE-2) ML_bmp_xor(bas,59,41,7,8);
			int2str(chaine,niveau+1);
			PrintXY(43,28,chaine,0);
			if(enregistrement[niveau]=='A') ML_bmp_or(verrou,112,25,13,13);
			else{
				if(enregistrement[niveau]=='C' || enregistrement[niveau]=='D' || enregistrement[niveau]=='E') ML_bmp_or(etoile,112,25,13,13);
				if(enregistrement[niveau]=='D' || enregistrement[niveau]=='E') ML_bmp_or(etoile,97,25,13,13);
				if(enregistrement[niveau]=='E') ML_bmp_or(etoile,82,25,13,13);
			}
			ML_display_vram();
			Sleep(300);
			while(IsKeyUp(KEY_CTRL_EXE) && IsKeyUp(KEY_CTRL_EXIT) && IsKeyUp(KEY_CTRL_UP) && IsKeyUp(KEY_CTRL_DOWN));
			if(IsKeyDown(KEY_CTRL_UP) && niveau>0) niveau--;
			if(IsKeyDown(KEY_CTRL_DOWN) && niveau<TAILLE-2) niveau++;
		} while(!(IsKeyDown(KEY_CTRL_EXE) && enregistrement[niveau]!='A') && IsKeyUp(KEY_CTRL_EXIT));
		while(IsKeyDown(KEY_CTRL_EXE) && enregistrement[niveau]!='A' && reussite!=1) {
			reussite = generer();
			if(reussite==0) break;
			if(reussite==3 && niveau==TAILLE-2){
				reussite=definitif();
			}
			if(reussite==3 && niveau<TAILLE-2) niveau++;
		}
		if(reussite==0) break;
	} while(IsKeyUp(KEY_CTRL_EXIT) && reussite);
	Bfile_CloseFile(handle);
	Bfile_DeleteFile(fichier);
	handle = Bfile_CreateFile(fichier,TAILLE);
	if(handle<0){
		erreur(handle);
		locate(13,4);
		Print("[EXIT]");
		ML_display_vram();
		while(!IsKeyDown(KEY_CTRL_EXIT));
		return 0;
	} else {
		handle = Bfile_OpenFile(fichier,_OPENMODE_READWRITE);
		if(handle<0){
			ML_clear_vram();
			erreur(handle);
			locate(13,4);
			Print("[EXIT]");
			ML_display_vram();
			while(!IsKeyDown(KEY_CTRL_EXIT));
			return 0;
		} else Bfile_WriteFile(handle,enregistrement,TAILLE-1);
	}
	Bfile_CloseFile(handle);
	louloux();
	return 1;
}

int main(){
	intro();
	return menu();
}

extern "C" {
int AddIn_main(int isAppli, unsigned short OptionNum)
{
    return main();
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum){
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section
}